import { PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from "xbsj-xe2/dist-node/xe2-base-utils";
import { SceneObjectKey } from "xbsj-xe2/dist-node/xe2-utils";
import { ESSceneObject } from "../ESSceneObject";
import { Watcher } from "../MiscObjects";
import { GeoCameraController } from "./GeoCameraController";
export declare class GeoPathCameraController extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("xbsj-xe2/dist-node/xe2-base-utils").JsonValue>;
        enabled: boolean;
        pathId: string;
        usePathPosition: boolean;
        usePathRotation: boolean;
        showTarget: boolean;
        viewDistance: number;
        offsetHeight: number;
        offsetRotation: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        enabledRotationInput: boolean;
        enabledScaleInput: boolean;
    };
    get json(): JsonType;
    set json(value: JsonType);
    private _geoCameraController;
    get geoCameraController(): GeoCameraController;
    private _watcher;
    get watcher(): Watcher;
    constructor(id?: SceneObjectKey);
    get position(): [number, number, number] | undefined;
    get positionChanged(): import("xbsj-xe2/dist-node/xe2-base-utils").Listener<[[number, number, number] | undefined, [number, number, number] | undefined]>;
    get rotation(): [number, number, number] | undefined;
    get roataionChanged(): import("xbsj-xe2/dist-node/xe2-base-utils").Listener<[[number, number, number] | undefined, [number, number, number] | undefined]>;
    getProperties(language?: string): import("../ESSceneObject").Property[];
}
export declare namespace GeoPathCameraController {
    const createDefaultProps: () => {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("xbsj-xe2/dist-node/xe2-base-utils").JsonValue>;
        enabled: boolean;
        pathId: string;
        usePathPosition: boolean;
        usePathRotation: boolean;
        showTarget: boolean;
        viewDistance: number;
        offsetHeight: number;
        offsetRotation: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        enabledRotationInput: boolean;
        enabledScaleInput: boolean;
    };
}
export interface GeoPathCameraController extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof GeoPathCameraController.createDefaultProps>> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof GeoPathCameraController.createDefaultProps> & {
    type: string;
}>;
export {};
